<?php 
/*****************************************************
	Guestget
Module:
	Guest Get MultiCURL
TIGRA electronic Inc.
Copyright, 02.2019
*****************************************************/

#      ,    1    .
#     IP      
#      ,  PHP    5.3,  CURL
#  : php.exe guestget.php guestance guestance1 guestance2 192.168.0.70

define( 'GUESTGET_DIRECTORY', 'reports\\' );					#    
define( 'GUESTGET_LOG', GUESTGET_DIRECTORY.'\\guestget.log' );	#    

define( 'GUESTGET_URL_JOURNAL', '/journal.cgi?t=a&f=c&d=a');	#  
#define( 'GUEST_URL_CARDS', '/cards.cgi?f=c');					#  
define( 'GUESTGET_URL_ID', '/id.xml');							#  id

define( 'GUESTGET_ACCESS', 'guest:guest' );		#   

#*******************    **************
define( 'EVENT_ON', 1 );
define( 'EVENT_OFF', 2 );
define( 'EVENT_TIME', 3 );

define( 'EVENT_PASSWORD', 4 );
define( 'EVENT_LOGIN', 5 );
define( 'EVENT_CARD_CHANGE', 6 );

define( 'EVENT_UPDATE_LOAD', 7 );
define( 'EVENT_UPDATE_COMPLETE', 8 );
define( 'EVENT_UPDATE_FAIL', 9 );

define( 'EVENT_INNOW', 10 );
define( 'EVENT_INOUT', 11 );

define( 'EVENT_EMITTER_SHOW', 12 );
define( 'EVENT_EMITTER_HIDE', 13 );

define( 'EVENT_EMAIL', 23 );
define( 'EVENT_CARD', 25 );

#*********************   *******************
define( 'GUESTGET_FILTER', [EVENT_INNOW, EVENT_INOUT] );

#*********************     *******************
define( 'GUESTGET_FILE_START', "52-3-3\r\n" );

#**********************        1 **********
define( 'GUESTGET_PATTERN', '/(\d+)\/(\d+)\/(\d+) ([\d: ]+),(\d+),(\d*),(\d*).*/' );
define( 'GUESTGET_REPLACE', "$1.$2.$3 $4:00	$6	$7\r\n" );

	ob_implicit_flush();
	date_default_timezone_set('Europe/Moscow');

class Guestget {
	public $id, $idx, $ip, $mh, $chs, $callback;
	function __construct( $idx, $ip, $mh, &$chs ) {
		$this->idx = $idx;
		$this->ip = $ip;
		$this->mh = $mh;
		$this->chs = &$chs;
		$this->request( GUESTGET_URL_ID );		#  id 
		$this->callback = "process_id";			#   id
	}
	function process_id() {
		if( !preg_match( "/<serial>([0-9]+)<\/serial>/",  $this->get(), $m ) ) {	//  id 
			$this->slog( "id error\n" );
			return;
		}
		$this->id = $m[1];
		$this->request( GUESTGET_URL_JOURNAL );	#  
		$this->callback = "process_journal";	#   
	}
	
	function process_journal() {
		$result = explode( "\n", $this->get() );#    
		if( $result == NULL )
			return;
		$csv = GUESTGET_FILE_START;			#    
		$filter = GUESTGET_FILTER;
		foreach( $result as $line ) {		#        
			if( strlen($line) < 10 )		#    
				continue;
			if( !in_array( explode(',', $line)[1], $filter ) )	#  
				continue;
			$csv .= preg_replace(GUESTGET_PATTERN, GUESTGET_REPLACE, $line);	#   
		}
		file_put_contents( GUESTGET_DIRECTORY.$this->id."_journal.csv", $csv );		#    
		$this->slog("work complete");
	}
		
	function request( $url ) {				#   
		$this->slog( "request $url" );
		$ch = curl_init( "http://".$this->ip.$url );
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);		#  
		curl_setopt($ch, CURLOPT_TIMEOUT, 30);
		curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
		curl_setopt($ch, CURLOPT_USERPWD, GUESTGET_ACCESS);	#   
		curl_multi_add_handle( $this->mh, $ch );
		$this->chs[$this->idx] = $this->ch = $ch;			#    
	}
	
	function get() {						#     
		$result = curl_multi_getcontent( $this->ch );
		$info = curl_getinfo($this->ch);
		curl_multi_remove_handle( $this->mh, $this->ch );
		curl_close($this->ch);
		
		if( !$result || $info['http_code'] != 200 ) {
			$this->slog( "HTTP error ".$info['http_code'] );
			return NULL;
		}
		$this->slog("request complete");
		return $result;
	}
	function process() {					#  -
		call_user_func( array( $this, $this->callback) );
	}
	function slog( $msg ) {				#       
		$str = date("r")." <".$this->ip."> $msg\r\n";
		echo $str;
		file_put_contents(GUESTGET_LOG, $str, FILE_APPEND);
    }
}

	$mh = curl_multi_init();	#  
	$threads = [];				#  
	$chs = [];					#  

	foreach( array_slice($argv, 1) as $ip )		#   IP  
		array_push( $threads, new Guestget(count($threads), $ip, $mh, $chs) );	#     

	$active = $prev_active = count($chs);
	while( 1 ) {							#    
		curl_multi_exec( $mh, $active );	#   
		if( $active != $prev_active ) {		#     
			$prev_active = $active;
			do {
				$infos = curl_multi_info_read( $mh, $queue );		#   
				if( is_array($infos) && ($ch = $infos['handle']) )
					$threads[array_search( $ch, $chs )]->process( $ch );#   
			} while( $queue );
		} else if( !$active )			#   
			break;
		usleep( 1000 );
	}
	curl_multi_close( $mh );
?>